<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small" v-show="showSearch" label-width="68px">
      <el-form-item label="年份" prop="duesTime">
        <el-date-picker clearable size="small" style="width: 200px"
                        v-model="queryParams.duesYear"
                        type="year"
                        placeholder="选择年份">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:dues:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:dues:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:dues:remove']"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--@click="handleImport"-->
          <!--v-hasPermi="['branch:dues:edit']"-->
        <!--&gt;导入</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:dues:export']"-->
        <!--&gt;导出</el-button>-->
      <!--</el-col>-->
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="duesList" @selection-change="handleSelectionChange" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="时间" align="center" prop="duesTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.duesTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="项目" align="center" prop="duesItem" />
      <el-table-column label="收/支" align="center" prop="duesInOut" :formatter="duesInOutFormat" />
      <el-table-column label="账面/现金" align="center" prop="duesType" :formatter="duesTypeFormat" />
      <el-table-column label="金额" align="center" prop="duesAmount" />
      <el-table-column label="备注" align="center" prop="remarks" />
      <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:dues:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:dues:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-descriptions direction="vertical" :column="4" border>
      <el-descriptions-item label="年度账面收入">{{calVO.ndzmsr}}元</el-descriptions-item>
      <el-descriptions-item label="年度账面支出">{{calVO.ndzmzc}}元</el-descriptions-item>
      <el-descriptions-item label="年度现金收入">{{calVO.ndxjsr}}元</el-descriptions-item>
      <el-descriptions-item label="年度现金支出">{{calVO.ndxjzc}}元</el-descriptions-item>
      <el-descriptions-item label="账面合计" :span="2">{{calVO.zmhj}}元</el-descriptions-item>
      <el-descriptions-item label="现金合计" :span="2">{{calVO.xjhj}}元</el-descriptions-item>
      <el-descriptions-item label="总合计" :span="4">{{calVO.zhj}}元</el-descriptions-item>
    </el-descriptions>

    <!--<pagination-->
      <!--v-show="total>0"-->
      <!--:total="total"-->
      <!--:page.sync="queryParams.pageNum"-->
      <!--:limit.sync="queryParams.pageSize"-->
      <!--@pagination="getList"-->
    <!--/>-->

    <!-- 添加或修改支部党费收支管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="时间" prop="duesTime">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.duesTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="项目" prop="duesItem">
          <el-input v-model="form.duesItem" placeholder="请输入项目" />
        </el-form-item>
        <el-form-item label="收/支" prop="duesInOut">
          <el-select v-model="form.duesInOut" placeholder="请选择收/支">
            <el-option
              v-for="dict in duesInOutOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="账面/现金" prop="duesType">
          <el-select v-model="form.duesType" placeholder="请选择账面/现金">
            <el-option
              v-for="dict in duesTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="金额" prop="duesAmount">
          <el-input v-model="form.duesAmount" placeholder="请输入金额" v-number />
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注" />
        </el-form-item>
          <el-form-item label="归属部门" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
          </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
        <el-upload
                ref="upload"
                :limit="1"
                accept=".xlsx, .xls"
                :headers="upload.headers"
                :action="upload.url + '?updateSupport=' + upload.updateSupport"
                :disabled="upload.isUploading"
                :on-progress="handleFileUploadProgress"
                :on-success="handleFileSuccess"
                :auto-upload="false"
                drag
        >
            <i class="el-icon-upload"></i>
            <div class="el-upload__text">
                将文件拖到此处，或
                <em>点击上传</em>
            </div>
            <div class="el-upload__tip" slot="tip">
                <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
            </div>
            <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
        </el-upload>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">确 定</el-button>
            <el-button @click="upload.open = false">取 消</el-button>
        </div>
    </el-dialog>
  </div>
</template>

<script>
import { calcDues, listDues, getDues, delDues, addDues, updateDues, exportDues, importTemplate} from "@/api/branch/dues";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Dues",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 支部党费收支管理表格数据
      duesList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: [],
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 主键id字典
      duesIdOptions: [],
      // 时间字典
      duesTimeOptions: [],
      // 项目字典
      duesItemOptions: [],
      // 党费进出，1收/0支字典
      duesInOutOptions: [],
      // 支付类型，1账面/0现金字典
      duesTypeOptions: [],
      // 金额字典
      duesAmountOptions: [],
      // 备注字典
      remarksOptions: [],
      // 删除标志字典
      delFlagOptions: [],
      // 创建者字典
      createByOptions: [],
      // 创建时间字典
      createTimeOptions: [],
      // 更新者字典
      updateByOptions: [],
      // 更新时间字典
      updateTimeOptions: [],
      // 部门id字典
      deptIdOptions: [],
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/branch/dues/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        duesId: null,
        duesTime: null,
        duesItem: null,
        duesInOut: null,
        duesType: null,
        duesAmount: null,
        remarks: null,
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        duesTime: [
          { required: true, message: "时间不能为空", trigger: "blur" }
        ],
        duesItem: [
          { required: true, message: "项目不能为空", trigger: "blur" }
        ],
        duesType: [
          { required: true, message: "账面/现金不能为空", trigger: "blur" }
        ],
        duesInOut: [
          { required: true, message: "收/支不能为空", trigger: "blur" }
        ],
        duesAmount: [
          { required: true,  message: '金额不能为空', trigger: 'blur' },
          { pattern: /^-?\d+\.?\d*$/, message: '金额不能为非数值', trigger: 'blur' }
        ],
        deptId: [
          { required: true, message: "归属部门不能为空", trigger: "blur" }
        ],
      },
      // 查询支部党费计算VO
      calVO: {
        ndzmsr: 0,
        ndzmzc: 0,
        ndxjsr: 0,
        ndxjzc: 0,
        zmhj: 0,
        xjhj: 0,
        zhj: 0,
      },
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    // 设置搜索条件年份为当年
    this.setYear();
    this.getList();
    this.getTreeselect();
    this.getDicts("dues_in_out").then(response => {
      this.duesInOutOptions = response.data;
    });
    this.getDicts("dues_type").then(response => {
      this.duesTypeOptions = response.data;
    });
  },
  methods: {
    /** 查询支部党费计算 */
    calcDues() {
      calcDues({
        "duesYear": this.queryParams.duesYear.getFullYear(),
        "deptId": this.queryParams.deptId
      }).then(response => {
        this.calVO = response.data;
      });
    },
    /** 计算总价方法 */
    getSummaries(param) {
      const { columns, data } = param;
      const sums = [];
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '合计';
          return;
        } else if (index === 5) {
          const values = data.map(item => Number(item[column.property]));
          if (!values.every(value => isNaN(value))) {
            sums[index] = values.reduce((prev, curr) => {
              const value = Number(curr);
              if (!isNaN(value)) {
                return prev + curr;
              } else {
                return prev;
              }
            }, 0);
            sums[index] += ' 元';
          } else {
            sums[index] = 'N/A';
          }
        } else {
          sums[index] = 'N/A';
        }
      });
      return sums;
    },
    /** 设置搜索条件年份 */
    setYear() {
      this.queryParams.duesYear = new Date();
    },
    /** 查询支部党费收支管理列表 */
    getList() {
      this.loading = true;
      listDues({
        "duesYear": this.queryParams.duesYear.getFullYear(),
        "deptId": this.queryParams.deptId
      }).then(response => {
        this.duesList = response.data;
        // this.total = response.total;
        this.loading = false;
      });
      this.calcDues();
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 党费进出，1收/0支字典翻译
    duesInOutFormat(row, column) {
      return this.selectDictLabel(this.duesInOutOptions, row.duesInOut);
    },
    // 支付类型，1账面/0现金字典翻译
    duesTypeFormat(row, column) {
      return this.selectDictLabel(this.duesTypeOptions, row.duesType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        duesId: null,
        duesTime: null,
        duesItem: null,
        duesInOut: null,
        duesType: null,
        duesAmount: null,
        remarks: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        deptId: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.duesId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加支部党费收支条目";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const duesId = row.duesId || this.ids
      getDues(duesId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改支部党费收支条目";
      });
    },
      /** 提交按钮 */
      submitForm() {
          this.$refs["form"].validate(valid => {
              if (valid) {
                  if (this.form.duesId != null) {
                      updateDues(this.form).then(response => {
                          this.$modal.msgSuccess("修改成功");
                          this.open = false;
                          this.getList();
                      });
                  } else {
                      addDues(this.form).then(response => {
                          this.$modal.msgSuccess("新增成功");
                          this.open = false;
                          this.getList();
                      });
                  }
              }
          });
      },
    /** 删除按钮操作 */
    handleDelete(row) {
      const duesIds = row.duesId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDues(duesIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有支部党费收支数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportDues(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      }
  }
};
</script>

<style>
    /** 文本换行符处理 */
    .el-table .cell{
        white-space: pre-wrap;
    }
    /** textarea字体 */
    textarea {
        font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
    }
</style>
